"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
require("jasmine");
var util = require("util");
var Actor_1 = require("./Actor");
var nextTick = util.promisify(process.nextTick);
function GenerateStep(messageFactory, messageFactoriesDuringCallback, suffix, messageAvailableImmediately) {
    var steps = [];
    for (var _i = 0, _a = [false, true]; _i < _a.length; _i++) {
        var asynchronous = _a[_i];
        for (var _b = 0, _c = [false, true]; _b < _c.length; _b++) {
            var reason = _c[_b];
            for (var _d = 0, _e = [0, 1, 2, 3]; _d < _e.length; _d++) {
                var messagesDuringCallback = _e[_d];
                steps.push({
                    description: (messageAvailableImmediately ? "continued by" : "") + " " + (reason ? "unsuccessful" : "successful") + " " + (asynchronous ? "asynchronous" : "synchronous") + "ly handled message during which " + messagesDuringCallback + " messages(s) are received",
                    asynchronous: asynchronous,
                    message: messageFactory("Test Message Content " + suffix),
                    messageAvailableImmediately: messageAvailableImmediately,
                    reason: reason ? { reasonContent: "Test Reason Content " + suffix } : null,
                    messagesDuringCallback: messageFactoriesDuringCallback
                        .slice(0, messagesDuringCallback + 1)
                        .map(function (factory, i) { return factory("Test Message During Callback Content " + suffix + " " + i); })
                });
            }
        }
    }
    return steps;
}
function RunSteps(steps) {
    var _this = this;
    describe(steps.map(function (step) { return step.description; }).join(" -> "), function () {
        var mailboxInstances = 0;
        var mailboxPush;
        var mailboxShift;
        var messageHandler;
        var messageHandlerA;
        var messageHandlerB;
        var messageHandlerC;
        var messageHandlerD;
        var messageHandlerE;
        var errorHandler;
        var actor;
        beforeAll(function () { return __awaiter(_this, void 0, void 0, function () {
            function MessageHandlerCalled(e) {
                return __awaiter(this, void 0, void 0, function () {
                    var stepId, step;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                stepId = mailboxShift.calls.count();
                                if (!(stepId < steps.length)) return [3 /*break*/, 3];
                                step = steps[stepId];
                                if (!step.asynchronous) return [3 /*break*/, 2];
                                return [4 /*yield*/, nextTick()];
                            case 1:
                                _a.sent();
                                _a.label = 2;
                            case 2:
                                step.messagesDuringCallback
                                    .forEach(function (message) { return actor.tell(message.key, message.value); });
                                if (step.reason) {
                                    throw step.reason;
                                }
                                _a.label = 3;
                            case 3: return [2 /*return*/];
                        }
                    });
                });
            }
            var Mailbox, _i, steps_1, step;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mailboxPush = jasmine.createSpy();
                        mailboxShift = jasmine.createSpy();
                        mailboxShift.and.callFake(function () {
                            var stepId = mailboxShift.calls.count();
                            if (stepId < steps.length) {
                                var step = steps[stepId];
                                if (step.messageAvailableImmediately) {
                                    return step.message;
                                }
                            }
                            return undefined;
                        });
                        Mailbox = /** @class */ (function () {
                            function Mailbox() {
                                this.push = mailboxPush;
                                this.shift = mailboxShift;
                                mailboxInstances++;
                            }
                            return Mailbox;
                        }());
                        messageHandlerA = jasmine.createSpy();
                        messageHandlerB = jasmine.createSpy();
                        messageHandlerB.and.callFake(MessageHandlerCalled);
                        messageHandlerC = jasmine.createSpy();
                        messageHandlerC.and.callFake(MessageHandlerCalled);
                        messageHandlerD = jasmine.createSpy();
                        messageHandlerD.and.callFake(MessageHandlerCalled);
                        messageHandlerE = jasmine.createSpy();
                        messageHandler = {
                            testKeyA: messageHandlerA,
                            testKeyB: messageHandlerB,
                            testKeyC: messageHandlerC,
                            testKeyD: messageHandlerD,
                            testKeyE: messageHandlerE
                        };
                        errorHandler = jasmine.createSpy();
                        actor = new Actor_1["default"](Mailbox, messageHandler, errorHandler);
                        _i = 0, steps_1 = steps;
                        _a.label = 1;
                    case 1:
                        if (!(_i < steps_1.length)) return [3 /*break*/, 8];
                        step = steps_1[_i];
                        if (!!step.messageAvailableImmediately) return [3 /*break*/, 4];
                        actor.tell(step.message.key, step.message.value);
                        return [4 /*yield*/, nextTick()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, nextTick()];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        if (!step.asynchronous) return [3 /*break*/, 7];
                        return [4 /*yield*/, nextTick()];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, nextTick()];
                    case 6:
                        _a.sent();
                        _a.label = 7;
                    case 7:
                        _i++;
                        return [3 /*break*/, 1];
                    case 8: return [2 /*return*/];
                }
            });
        }); });
        it("creates exactly one mailbox", function () { return expect(mailboxInstances).toEqual(1); });
        it("pushes the expected number of messages to the mailbox", function () { return expect(mailboxPush).toHaveBeenCalledTimes(steps
            .map(function (step) { return step.messagesDuringCallback.length; })
            .reduce(function (a, b) { return a + b; }, 0)); });
        it("pushes every expected message to the mailbox", function () { return steps
            .forEach(function (step) { return step.messagesDuringCallback
            .forEach(function (message) { return expect(mailboxPush).toHaveBeenCalledWith(message); }); }); });
        it("shifts from the mailbox the expected number of times", function () { return expect(mailboxShift).toHaveBeenCalledTimes(steps.length); });
        it("handles the expected number of messages", function () {
            expect(messageHandlerA).toHaveBeenCalledTimes(0);
            expect(messageHandlerB).toHaveBeenCalledTimes(steps.filter(function (step) { return step.message.key == "testKeyB"; }).length);
            expect(messageHandlerC).toHaveBeenCalledTimes(steps.filter(function (step) { return step.message.key == "testKeyC"; }).length);
            expect(messageHandlerD).toHaveBeenCalledTimes(steps.filter(function (step) { return step.message.key == "testKeyD"; }).length);
            expect(messageHandlerE).toHaveBeenCalledTimes(0);
        });
        it("handles the expected messages", function () { return steps.forEach(function (step) {
            switch (step.message.key) {
                case "testKeyB":
                    expect(messageHandlerB).toHaveBeenCalledWith(jasmine.anything(), step.message.value);
                    break;
                case "testKeyC":
                    expect(messageHandlerC).toHaveBeenCalledWith(jasmine.anything(), step.message.value);
                    break;
                case "testKeyD":
                    expect(messageHandlerD).toHaveBeenCalledWith(jasmine.anything(), step.message.value);
                    break;
            }
        }); });
        it("provides a reference to itself when handling messages", function () { return [messageHandlerB, messageHandlerC, messageHandlerD]
            .forEach(function (messageHandler) { return messageHandler
            .calls
            .allArgs()
            .forEach(function (call) { return expect(call[0]).toBe(actor); }); }); });
        it("handles the expected number of errors", function () { return expect(errorHandler)
            .toHaveBeenCalledTimes(steps.filter(function (step) { return step.reason; }).length); });
    });
}
function MessageFactoryB(content) {
    return {
        key: "testKeyB",
        value: content
    };
}
function MessageFactoryC(content) {
    return {
        key: "testKeyC",
        value: content
    };
}
function MessageFactoryD(content) {
    return {
        key: "testKeyD",
        value: content
    };
}
RunSteps([]);
describe("tell", function () {
    GenerateStep(MessageFactoryC, [MessageFactoryB, MessageFactoryD, MessageFactoryC], "A", false)
        .forEach(function (a) {
        RunSteps([a]);
        GenerateStep(MessageFactoryD, [MessageFactoryC, MessageFactoryD, MessageFactoryB], "B", false)
            .forEach(function (b) {
            RunSteps([a, b]);
            GenerateStep(MessageFactoryB, [MessageFactoryD, MessageFactoryB, MessageFactoryC], "C", false)
                .forEach(function (c) { return RunSteps([a, b, c]); });
            GenerateStep(MessageFactoryB, [MessageFactoryD, MessageFactoryB, MessageFactoryC], "C", true).forEach(function (c) { return RunSteps([a, b, c]); });
        });
        GenerateStep(MessageFactoryD, [MessageFactoryC, MessageFactoryD, MessageFactoryB], "B", true)
            .forEach(function (b) {
            RunSteps([a, b]);
            GenerateStep(MessageFactoryB, [MessageFactoryD, MessageFactoryB, MessageFactoryC], "C", false).forEach(function (c) { return RunSteps([a, b, c]); });
            GenerateStep(MessageFactoryB, [MessageFactoryD, MessageFactoryB, MessageFactoryC], "C", true).forEach(function (c) { return RunSteps([a, b, c]); });
        });
    });
});
//# sourceMappingURL=Actor.Tests.js.map