"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.__esModule = true;
require("jasmine");
var FilePlugin_1 = require("./FilePlugin");
var fsReadFile;
var pathDirname;
var mkdirp;
var fsWriteFile;
var fsRename;
var filePlugin;
beforeEach(function () {
    fsReadFile = jasmine.createSpy();
    pathDirname = jasmine.createSpy();
    mkdirp = jasmine.createSpy();
    fsWriteFile = jasmine.createSpy();
    fsRename = jasmine.createSpy();
    filePlugin = new FilePlugin_1["default"](fsReadFile, pathDirname, mkdirp, fsWriteFile, fsRename, "Test Filename");
});
it("has a name of \"File\"", function () { return expect(filePlugin.name).toEqual("File"); });
it("does not call fs.readFile", function () { return expect(fsReadFile).not.toHaveBeenCalled(); });
it("does not call path.dirname", function () { return expect(pathDirname).not.toHaveBeenCalled(); });
it("does not call mkdirp", function () { return expect(mkdirp).not.toHaveBeenCalled(); });
it("does not call fsWriteFile", function () { return expect(fsWriteFile).not.toHaveBeenCalled(); });
it("does not call fs.rename", function () { return expect(fsRename).not.toHaveBeenCalled(); });
describe("install", function () {
    var receivedByTell;
    var receivedBy;
    var coreTell;
    var applicationInitial;
    var applicationApply;
    var stateGet;
    var loggerTell;
    var installed;
    beforeEach(function () {
        receivedByTell = jasmine.createSpy();
        coreTell = jasmine.createSpy();
        applicationInitial = jasmine.createSpy();
        applicationApply = jasmine.createSpy();
        stateGet = jasmine.createSpy();
        loggerTell = jasmine.createSpy();
        installed = {
            core: {
                tell: coreTell
            },
            application: {
                title: "Test Application Title",
                initial: applicationInitial,
                apply: applicationApply
            },
            state: {
                get: stateGet
            },
            logger: {
                tell: loggerTell
            }
        };
    });
    var DummyError = /** @class */ (function (_super) {
        __extends(DummyError, _super);
        function DummyError(code) {
            var _this = _super.call(this) || this;
            _this.errno = undefined;
            _this.path = undefined;
            _this.syscall = undefined;
            _this.code = code;
            return _this;
        }
        return DummyError;
    }(Error));
    describe("when the file exists", function () {
        var deserializedState;
        beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        deserializedState = { stateContent: "Test Deserialized State Content" };
                        fsReadFile.and.callFake(function (path, options, callback) { return callback(null, JSON.stringify(deserializedState)); });
                        return [4 /*yield*/, filePlugin.installed(receivedBy, installed)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it("calls fs.readFile once", function () { return expect(fsReadFile).toHaveBeenCalledTimes(1); });
        it("calls fs.readFile with the filename", function () { return expect(fsReadFile).toHaveBeenCalledWith("Test Filename", jasmine.anything(), jasmine.anything()); });
        it("calls fs.readFile with a utf-8 encoding", function () { return expect(fsReadFile).toHaveBeenCalledWith(jasmine.anything(), { encoding: "utf8" }, jasmine.anything()); });
        it("does not call path.dirname", function () { return expect(pathDirname).not.toHaveBeenCalled(); });
        it("does not call mkdirp", function () { return expect(mkdirp).not.toHaveBeenCalled(); });
        it("does not call fs.writeFile", function () { return expect(fsWriteFile).not.toHaveBeenCalled(); });
        it("does not call fs.rename", function () { return expect(fsRename).not.toHaveBeenCalled(); });
        it("does not tell itself", function () { return expect(receivedByTell).not.toHaveBeenCalled(); });
        it("tells the core once", function () { return expect(coreTell).toHaveBeenCalledTimes(1); });
        it("tells the core that state is to be replaced", function () { return expect(coreTell).toHaveBeenCalledWith("replaceState", {
            state: deserializedState
        }); });
        it("does not call application.initial", function () { return expect(applicationInitial).not.toHaveBeenCalled(); });
        it("does not call application.apply", function () { return expect(applicationApply).not.toHaveBeenCalled(); });
        it("does not call state.get", function () { return expect(stateGet).not.toHaveBeenCalled(); });
        it("logs once", function () { return expect(loggerTell).toHaveBeenCalledTimes(1); });
        it("logs to indicate that state is being restored", function () { return expect(loggerTell).toHaveBeenCalledWith("verbose", "\"Test Filename\" exists; restoring state..."); });
        Then();
    });
    describe("when the file does not exist", function () {
        beforeEach(function () {
            pathDirname.and.returnValue("Test Filename Dirname");
            fsReadFile.and.callFake(function (path, options, callback) { return callback(new DummyError("ENOENT"), null); });
        });
        describe("when the directory can be created", function () {
            beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            mkdirp.and.callFake(function (p, cb) { return cb(null, p); });
                            return [4 /*yield*/, filePlugin.installed(receivedBy, installed)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it("calls fs.readFile once", function () { return expect(fsReadFile).toHaveBeenCalledTimes(1); });
            it("calls fs.readFile with the filename", function () { return expect(fsReadFile).toHaveBeenCalledWith("Test Filename", jasmine.anything(), jasmine.anything()); });
            it("calls fs.readFile with a utf-8 encoding", function () { return expect(fsReadFile).toHaveBeenCalledWith(jasmine.anything(), { encoding: "utf8" }, jasmine.anything()); });
            it("calls path.dirname once", function () { return expect(pathDirname).toHaveBeenCalledTimes(1); });
            it("calls path.dirname with the filename", function () { return expect(pathDirname).toHaveBeenCalledWith("Test Filename"); });
            it("calls mkdirp once", function () { return expect(mkdirp).toHaveBeenCalledTimes(1); });
            it("calls mkdirp with the dirname of the filename", function () { return expect(mkdirp)
                .toHaveBeenCalledWith("Test Filename Dirname", jasmine.anything()); });
            it("does not call fs.writeFile", function () { return expect(fsWriteFile).not.toHaveBeenCalled(); });
            it("does not call fs.rename", function () { return expect(fsRename).not.toHaveBeenCalled(); });
            it("does not tell itself", function () { return expect(receivedByTell).not.toHaveBeenCalled(); });
            it("does not tell the core", function () { return expect(coreTell).not.toHaveBeenCalled(); });
            it("does not call application.initial", function () { return expect(applicationInitial).not.toHaveBeenCalled(); });
            it("does not call application.apply", function () { return expect(applicationApply).not.toHaveBeenCalled(); });
            it("does not call state.get", function () { return expect(stateGet).not.toHaveBeenCalled(); });
            it("logs once", function () { return expect(loggerTell).toHaveBeenCalledTimes(1); });
            it("logs to indicate that state is being restored", function () { return expect(loggerTell).toHaveBeenCalledWith("verbose", "\"Test Filename\" does not exist; ensuring that directory "
                + "\"Test Filename Dirname\" exists..."); });
            Then();
        });
        describe("when the directory cannot be created", function () {
            var thrown;
            beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
                var e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            mkdirp.and.callFake(function (p, cb) { return cb("Test Error", null); });
                            thrown = null;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, filePlugin.installed(receivedBy, installed)];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            thrown = e_1;
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            }); });
            it("calls fs.readFile once", function () { return expect(fsReadFile).toHaveBeenCalledTimes(1); });
            it("calls fs.readFile with the filename", function () { return expect(fsReadFile).toHaveBeenCalledWith("Test Filename", jasmine.anything(), jasmine.anything()); });
            it("calls fs.readFile with a utf-8 encoding", function () { return expect(fsReadFile).toHaveBeenCalledWith(jasmine.anything(), { encoding: "utf8" }, jasmine.anything()); });
            it("calls path.dirname once", function () { return expect(pathDirname).toHaveBeenCalledTimes(1); });
            it("calls path.dirname with the filename", function () { return expect(pathDirname).toHaveBeenCalledWith("Test Filename"); });
            it("calls mkdirp once", function () { return expect(mkdirp).toHaveBeenCalledTimes(1); });
            it("calls mkdirp with the dirname of the filename", function () { return expect(mkdirp)
                .toHaveBeenCalledWith("Test Filename Dirname", jasmine.anything()); });
            it("does not call fs.writeFile", function () { return expect(fsWriteFile).not.toHaveBeenCalled(); });
            it("does not call fs.rename", function () { return expect(fsRename).not.toHaveBeenCalled(); });
            it("does not tell itself", function () { return expect(receivedByTell).not.toHaveBeenCalled(); });
            it("does not tell the core", function () { return expect(coreTell).not.toHaveBeenCalled(); });
            it("does not call application.initial", function () { return expect(applicationInitial).not.toHaveBeenCalled(); });
            it("does not call application.apply", function () { return expect(applicationApply).not.toHaveBeenCalled(); });
            it("does not call state.get", function () { return expect(stateGet).not.toHaveBeenCalled(); });
            it("logs once", function () { return expect(loggerTell).toHaveBeenCalledTimes(1); });
            it("logs to indicate that state is being restored", function () { return expect(loggerTell).toHaveBeenCalledWith("verbose", "\"Test Filename\" does not exist; ensuring that directory "
                + "\"Test Filename Dirname\" exists..."); });
            it("throws the error raised by mkdirp", function () { return expect(thrown).toBe("Test Error"); });
        });
    });
    function Then() {
        describe("then", function () {
            beforeEach(function () {
                fsReadFile.calls.reset();
                pathDirname.calls.reset();
                mkdirp.calls.reset();
                coreTell.calls.reset();
                loggerTell.calls.reset();
            });
            function StateChanged(description, event) {
                var _this = this;
                var stateToWrite;
                var eventToWrite;
                beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        stateToWrite = { stateContent: "Test Written State" };
                        eventToWrite = JSON.parse(JSON.stringify(event));
                        return [2 /*return*/];
                    });
                }); });
                describe("when writing the temporary file fails", function () {
                    var error;
                    var thrown;
                    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
                        var e_2;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    error = new DummyError("UNEXPECTED");
                                    fsWriteFile.and.callFake(function (path, data, callback) { return callback(error); });
                                    thrown = null;
                                    _a.label = 1;
                                case 1:
                                    _a.trys.push([1, 3, , 4]);
                                    return [4 /*yield*/, filePlugin.stateChanged(receivedBy, {
                                            state: stateToWrite,
                                            event: eventToWrite
                                        })];
                                case 2:
                                    _a.sent();
                                    return [3 /*break*/, 4];
                                case 3:
                                    e_2 = _a.sent();
                                    thrown = e_2;
                                    return [3 /*break*/, 4];
                                case 4: return [2 /*return*/];
                            }
                        });
                    }); });
                    it("does not call fs.readFile", function () { return expect(fsReadFile).not.toHaveBeenCalled(); });
                    it("does not call path.dirname", function () { return expect(pathDirname).not.toHaveBeenCalled(); });
                    it("does not call mkdirp", function () { return expect(mkdirp).not.toHaveBeenCalled(); });
                    it("calls fs.writeFile once", function () { return expect(fsWriteFile).toHaveBeenCalledTimes(1); });
                    it("calls fs.writeFile with the filename (with .tmp appended)", function () { return expect(fsWriteFile).toHaveBeenCalledWith("Test Filename.tmp", jasmine.anything(), jasmine.anything()); });
                    it("calls fs.writeFile with the serialized state", function () { return expect(fsWriteFile).toHaveBeenCalledWith(jasmine.anything(), JSON.stringify(stateToWrite), jasmine.anything()); });
                    it("does not call fs.rename", function () { return expect(fsRename).not.toHaveBeenCalled(); });
                    it("does not tell itself", function () { return expect(receivedByTell).not.toHaveBeenCalled(); });
                    it("does not tell the core", function () { return expect(coreTell).not.toHaveBeenCalled(); });
                    it("does not call application.initial", function () { return expect(applicationInitial).not.toHaveBeenCalled(); });
                    it("does not call application.apply", function () { return expect(applicationApply).not.toHaveBeenCalled(); });
                    it("does not call state.get", function () { return expect(stateGet).not.toHaveBeenCalled(); });
                    it("does not log", function () { return expect(loggerTell).not.toHaveBeenCalled(); });
                    it("throws the error raised by fs.writeFile", function () { return expect(thrown).toBe(error); });
                });
                describe("when renaming the temporary file fails", function () {
                    var error;
                    var thrown;
                    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
                        var e_3;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    error = new DummyError("UNEXPECTED");
                                    fsWriteFile.and.callFake(function (path, data, callback) { return callback(null); });
                                    fsRename.and.callFake(function (oldPath, newPath, callback) { return callback(error); });
                                    thrown = null;
                                    _a.label = 1;
                                case 1:
                                    _a.trys.push([1, 3, , 4]);
                                    return [4 /*yield*/, filePlugin.stateChanged(receivedBy, {
                                            state: stateToWrite,
                                            event: eventToWrite
                                        })];
                                case 2:
                                    _a.sent();
                                    return [3 /*break*/, 4];
                                case 3:
                                    e_3 = _a.sent();
                                    thrown = e_3;
                                    return [3 /*break*/, 4];
                                case 4: return [2 /*return*/];
                            }
                        });
                    }); });
                    it("does not call fs.readFile", function () { return expect(fsReadFile).not.toHaveBeenCalled(); });
                    it("does not call path.dirname", function () { return expect(pathDirname).not.toHaveBeenCalled(); });
                    it("does not call mkdirp", function () { return expect(mkdirp).not.toHaveBeenCalled(); });
                    it("calls fs.writeFile once", function () { return expect(fsWriteFile).toHaveBeenCalledTimes(1); });
                    it("calls fs.writeFile with the filename (with .tmp appended)", function () { return expect(fsWriteFile).toHaveBeenCalledWith("Test Filename.tmp", jasmine.anything(), jasmine.anything()); });
                    it("calls fs.writeFile with the serialized state", function () { return expect(fsWriteFile).toHaveBeenCalledWith(jasmine.anything(), JSON.stringify(stateToWrite), jasmine.anything()); });
                    it("calls fs.rename once", function () { return expect(fsRename).toHaveBeenCalledTimes(1); });
                    it("calls fs.rename with the temporary file name", function () { return expect(fsRename).toHaveBeenCalledWith("Test Filename.tmp", jasmine.anything(), jasmine.anything()); });
                    it("calls fs.rename with the final file name", function () { return expect(fsRename).toHaveBeenCalledWith(jasmine.anything(), "Test Filename", jasmine.anything()); });
                    it("does not tell itself", function () { return expect(receivedByTell).not.toHaveBeenCalled(); });
                    it("does not tell the core", function () { return expect(coreTell).not.toHaveBeenCalled(); });
                    it("does not call application.initial", function () { return expect(applicationInitial).not.toHaveBeenCalled(); });
                    it("does not call application.apply", function () { return expect(applicationApply).not.toHaveBeenCalled(); });
                    it("does not log", function () { return expect(loggerTell).not.toHaveBeenCalled(); });
                    it("throws the error raised by fs.rename", function () { return expect(thrown).toBe(error); });
                });
                describe("when successful", function () {
                    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    fsWriteFile.and.callFake(function (path, data, callback) { return callback(null); });
                                    fsRename.and.callFake(function (oldPath, newPath, callback) { return callback(null); });
                                    return [4 /*yield*/, filePlugin.stateChanged(receivedBy, {
                                            state: stateToWrite,
                                            event: eventToWrite
                                        })];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    it("does not call fs.readFile", function () { return expect(fsReadFile).not.toHaveBeenCalled(); });
                    it("does not call path.dirname", function () { return expect(pathDirname).not.toHaveBeenCalled(); });
                    it("does not call mkdirp", function () { return expect(mkdirp).not.toHaveBeenCalled(); });
                    it("calls fs.writeFile once", function () { return expect(fsWriteFile).toHaveBeenCalledTimes(1); });
                    it("calls fs.writeFile with the filename (with .tmp appended)", function () { return expect(fsWriteFile).toHaveBeenCalledWith("Test Filename.tmp", jasmine.anything(), jasmine.anything()); });
                    it("calls fs.writeFile with the serialized state", function () { return expect(fsWriteFile).toHaveBeenCalledWith(jasmine.anything(), JSON.stringify(stateToWrite), jasmine.anything()); });
                    it("calls fs.rename once", function () { return expect(fsRename).toHaveBeenCalledTimes(1); });
                    it("calls fs.rename with the temporary file name", function () { return expect(fsRename).toHaveBeenCalledWith("Test Filename.tmp", jasmine.anything(), jasmine.anything()); });
                    it("calls fs.rename with the final file name", function () { return expect(fsRename).toHaveBeenCalledWith(jasmine.anything(), "Test Filename", jasmine.anything()); });
                    it("does not tell itself", function () { return expect(receivedByTell).not.toHaveBeenCalled(); });
                    it("does not tell the core", function () { return expect(coreTell).not.toHaveBeenCalled(); });
                    it("does not call application.initial", function () { return expect(applicationInitial).not.toHaveBeenCalled(); });
                    it("does not call application.apply", function () { return expect(applicationApply).not.toHaveBeenCalled(); });
                    it("does not call state.get", function () { return expect(stateGet).not.toHaveBeenCalled(); });
                    it("does not log", function () { return expect(loggerTell).not.toHaveBeenCalled(); });
                });
            }
            StateChanged("stateChanged with event", { eventContent: "Test Written Event" });
            StateChanged("stateChanged without event", null);
        });
    }
    describe("when the file cannot be read", function () {
        var error;
        var thrown;
        beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
            var e_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        pathDirname.and.returnValue("Test Filename Dirname");
                        error = new DummyError("UNEXPECTED");
                        fsReadFile.and.callFake(function (path, options, callback) { return callback(error, null); });
                        thrown = null;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, filePlugin.installed(receivedBy, installed)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_4 = _a.sent();
                        thrown = e_4;
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it("calls fs.readFile once", function () { return expect(fsReadFile).toHaveBeenCalledTimes(1); });
        it("calls fs.readFile with the filename", function () { return expect(fsReadFile).toHaveBeenCalledWith("Test Filename", jasmine.anything(), jasmine.anything()); });
        it("calls fs.readFile with a utf-8 encoding", function () { return expect(fsReadFile).toHaveBeenCalledWith(jasmine.anything(), { encoding: "utf8" }, jasmine.anything()); });
        it("deos not call path.dirname", function () { return expect(pathDirname).not.toHaveBeenCalled(); });
        it("does not call mkdirp", function () { return expect(mkdirp).not.toHaveBeenCalled(); });
        it("does not call fs.writeFile", function () { return expect(fsWriteFile).not.toHaveBeenCalled(); });
        it("does not call fs.rename", function () { return expect(fsRename).not.toHaveBeenCalled(); });
        it("does not tell itself", function () { return expect(receivedByTell).not.toHaveBeenCalled(); });
        it("does not tell the core", function () { return expect(coreTell).not.toHaveBeenCalled(); });
        it("does not call application.initial", function () { return expect(applicationInitial).not.toHaveBeenCalled(); });
        it("does not call application.apply", function () { return expect(applicationApply).not.toHaveBeenCalled(); });
        it("does not call state.get", function () { return expect(stateGet).not.toHaveBeenCalled(); });
        it("does not log", function () { return expect(loggerTell).not.toHaveBeenCalled(); });
        it("throws the error raised by fs.readFile", function () { return expect(thrown).toBe(error); });
    });
});
//# sourceMappingURL=FilePlugin.Tests.js.map