import { MultiMessageHandler } from "../Actors/IMultiMessageHandler";
import IActor from "../Actors/IActor";
import ILogMessages from "./ILogMessages";
/**
 * Logs to the JavaScript console.
 */
export default class ConsoleLogger implements MultiMessageHandler<ILogMessages> {
    /**
     * Enables dependency injection in tests.
     */
    Date: {
        new (): {
            toISOString(): string;
        };
    };
    /**
     * Enables dependency injection in tests.
     */
    console: {
        log(message: string): void;
        info(message: string): void;
        warn(message: string): void;
        error(message: string): void;
    };
    /**
     * @inheritdoc
     */
    verbose(receivedBy: IActor<ILogMessages>, message: {
        readonly instigator: string;
        readonly message: string;
    }): Promise<void>;
    /**
     * @inheritdoc
     */
    information(receivedBy: IActor<ILogMessages>, message: {
        readonly instigator: string;
        readonly message: string;
    }): Promise<void>;
    /**
     * @inheritdoc
     */
    warning(receivedBy: IActor<ILogMessages>, message: {
        readonly instigator: string;
        readonly message: string;
    }): Promise<void>;
    /**
     * @inheritdoc
     */
    error(receivedBy: IActor<ILogMessages>, message: {
        readonly instigator: string;
        readonly message: string;
    }): Promise<void>;
}
