"use strict";
exports.__esModule = true;
require("jasmine");
var LoggerProxy_1 = require("./LoggerProxy");
var logger;
var loggerTell;
var loggerProxy;
beforeEach(function () {
    loggerTell = jasmine.createSpy();
    logger = {
        tell: loggerTell
    };
    loggerProxy = new LoggerProxy_1["default"](logger, "Test Name");
});
it("does not tell any messages to the proxied logger", function () { return expect(loggerTell).not.toHaveBeenCalled(); });
describe("verbose", function () {
    beforeEach(function () { return loggerProxy.tell("verbose", "Test Message"); });
    it("tells one message to the proxied logger", function () { return expect(loggerTell).toHaveBeenCalledTimes(1); });
    it("tells the proxied logger to log a verbose message", function () { return expect(loggerTell).toHaveBeenCalledWith("verbose", {
        instigator: "Test Name",
        message: "Test Message"
    }); });
});
describe("information", function () {
    beforeEach(function () { return loggerProxy.tell("information", "Test Message"); });
    it("tells one message to the proxied logger", function () { return expect(loggerTell).toHaveBeenCalledTimes(1); });
    it("tells the proxied logger to log a information message", function () { return expect(loggerTell).toHaveBeenCalledWith("information", {
        instigator: "Test Name",
        message: "Test Message"
    }); });
});
describe("warning", function () {
    beforeEach(function () { return loggerProxy.tell("warning", "Test Message"); });
    it("tells one message to the proxied logger", function () { return expect(loggerTell).toHaveBeenCalledTimes(1); });
    it("tells the proxied logger to log a warning message", function () { return expect(loggerTell).toHaveBeenCalledWith("warning", {
        instigator: "Test Name",
        message: "Test Message"
    }); });
});
describe("error", function () {
    beforeEach(function () { return loggerProxy.tell("error", "Test Message"); });
    it("tells one message to the proxied logger", function () { return expect(loggerTell).toHaveBeenCalledTimes(1); });
    it("tells the proxied logger to log a error message", function () { return expect(loggerTell).toHaveBeenCalledWith("error", {
        instigator: "Test Name",
        message: "Test Message"
    }); });
});
//# sourceMappingURL=LoggerProxy.Tests.js.map