"use strict";
exports.__esModule = true;
var StateContainer_1 = require("./StateContainer");
var State;
(function (State) {
    State[State["A"] = 0] = "A";
    State[State["FirstChange"] = 1] = "FirstChange";
    State[State["C"] = 2] = "C";
    State[State["Initial"] = 3] = "Initial";
    State[State["E"] = 4] = "E";
    State[State["SecondChange"] = 5] = "SecondChange";
    State[State["G"] = 6] = "G";
})(State || (State = {}));
var stateContainer;
var got;
beforeEach(function () { return stateContainer = new StateContainer_1["default"](State.Initial); });
ExpectState(State.Initial, function () { });
function ExpectState(state, then) {
    describe("get", function () {
        beforeEach(function () { return got = stateContainer.get(); });
        it("returns the expected state", function () { return expect(got).toEqual(state); });
        then();
        describe("get", function () {
            beforeEach(function () { return got = stateContainer.get(); });
            it("returns the expected state", function () { return expect(got).toEqual(state); });
            then();
        });
    });
}
describe("set", function () {
    beforeEach(function () { return stateContainer.set(State.FirstChange); });
    ExpectState(State.FirstChange, SetAgain);
    SetAgain();
    function SetAgain() {
        describe("set", function () {
            beforeEach(function () { return stateContainer.set(State.SecondChange); });
            ExpectState(State.SecondChange, function () { });
        });
    }
});
//# sourceMappingURL=StateContainer.Tests.js.map