"use strict";
exports.__esModule = true;
/**
 * @inheritdoc
 */
var StateSet = /** @class */ (function () {
    function StateSet() {
        this.states = [];
    }
    /**
     * @inheritdoc
     */
    StateSet.prototype.add = function (state) {
        this.states.push(state);
    };
    /**
     * @inheritdoc
     */
    StateSet.prototype.process = function (handler) {
        for (var i = 0; i < this.states.length;) {
            var newState = handler(this.states[i]);
            if (newState == null) {
                this.states.splice(i, 1);
            }
            else {
                this.states[i] = newState;
                i++;
            }
        }
    };
    return StateSet;
}());
exports["default"] = StateSet;
//# sourceMappingURL=StateSet.js.map